//+------------------------------------------------------------------+
//|                                                Bubble System.mq4 |
//|                                    Copyright  2013, financewave |
//|                                           financewaves@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2013, financewave"
#property link      "http://www.financewave.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Blue//wick
#property indicator_color2 Red//wick
#property indicator_color3 Blue//candle
#property indicator_color4 Red//candle
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 3
#property indicator_width4 3


//---- input parameters
extern int	BarWidth			= 1,
				CandleWidth		= 3;

//---- buffers
double Bar1[],
		 Bar2[],
		 Candle1[],
		 Candle2[];
		 
extern int rsip=14;
extern double rsilevel=30;
extern int adxp=14;
extern int standp=20;
extern int macd1p=12;
extern int macd2p=26;
extern int macd3p=9;
		 

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
//---- indicators
	IndicatorShortName("Bubble System");
	IndicatorBuffers(4);
	SetIndexBuffer(0,Bar1);
	SetIndexBuffer(1,Bar2);				
	SetIndexBuffer(2,Candle1);
	SetIndexBuffer(3,Candle2);
	SetIndexStyle(0,DRAW_HISTOGRAM,0,BarWidth);
	SetIndexStyle(1,DRAW_HISTOGRAM,0,BarWidth);
	SetIndexStyle(2,DRAW_HISTOGRAM,0,CandleWidth);
	SetIndexStyle(3,DRAW_HISTOGRAM,0,CandleWidth);

	return(0);
}

//+------------------------------------------------------------------+





//+------------------------------------------------------------------+
void SetCandleColor(int col, int i)
{
	double high,low,bodyHigh,bodyLow;


	{
		bodyHigh = MathMax(Open[i],Close[i]);
		bodyLow  = MathMin(Open[i],Close[i]);
		high		= High[i];
		low		= Low[i];
	}

	Bar1[i] = low;	Candle1[i] = bodyLow;
	Bar2[i] = low;	Candle2[i] = bodyLow;
	

	switch(col)
	{
		case 1: 	Bar1[i] = high;	Candle1[i] = bodyHigh;	break;
		case 2: 	Bar2[i] = high;	Candle2[i] = bodyHigh;	break;
	
	}
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
	for(int i = MathMax(Bars-1-IndicatorCounted(),1); i>=0; i--)
	{

double RSI = iRSI(NULL, 0, rsip, PRICE_CLOSE, i);
double ADX1 = iADX(NULL, 0, adxp+1, PRICE_CLOSE, MODE_MAIN, i);
double ADX2 = iADX(NULL, 0, adxp, PRICE_CLOSE, MODE_MAIN, i+1);
double Stand1 = iStdDev(NULL, 0, standp+1, MODE_SMA, 0, PRICE_CLOSE, i);
double Stand2 = iStdDev(NULL, 0, standp, MODE_SMA, 0, PRICE_CLOSE, i+1);
double MACD1 = iMACD(NULL, 0, macd1p+1, macd2p+1, macd3p+1, PRICE_CLOSE, MODE_MAIN, i);
double MACD2 = iMACD(NULL, 0, macd1p, macd2p, macd3p, PRICE_CLOSE, MODE_MAIN, i+1);


				if(RSI<rsilevel && ADX1<ADX2 && Stand1<Stand2 && MACD1>MACD2)		SetCandleColor(1,i);

	  	else	if(RSI>100-rsilevel && ADX1<ADX2 && Stand1<Stand2 && MACD1<MACD2)		SetCandleColor(2,i);
		
	}
	

	return(0);
}
//+------------------------------------------------------------------+

